# FDTD - 2D


## Description

"Finite-difference time-domain or Yee's method (named after the Chinese American
applied mathematician Kane S. Yee, born 1934) is a numerical analysis technique
used for modeling computational electrodynamics (finding approximate solutions
to the associated system of differential equations). Since it is a time-domain
method, FDTD solutions can cover a wide frequency range with a single simulation
run, and treat nonlinear material properties in a natural way."
([Wikipedia][wikipedia-fdtd])


## Task Graph comparison

### Auto Parallel Task Graph

![AutoParallel Task Graph](./results/local/autoparallel/complete_graph.png)

### User Parallel Task Graph

![UserParallel Task Graph](./results/local/userparallel/complete_graph.png)


[wikipedia-fdtd]: https://en.wikipedia.org/wiki/Finite-difference_time-domain_method