# Jacobi - 2D


## Description

"In numerical linear algebra, the Jacobi method (or Jacobi iterative method) is an
algorithm for determining the solutions of a diagonally dominant system of linear
equations. Each diagonal element is solved for, and an approximate value is plugged
in. The process is then iterated until it converges. This algorithm is a stripped-down
version of the Jacobi transformation method of matrix diagonalization. The method
is named after Carl Gustav Jacob Jacobi." 
([Wikipedia][wikipedia-jacobi])


## Task Graph comparison

### Auto Parallel Task Graph

![AutoParallel Task Graph](./results/local/autoparallel/complete_graph.png)

### User Parallel Task Graph

![UserParallel Task Graph](./results/local/userparallel/complete_graph.png)


[wikipedia-jacobi]: https://en.wikipedia.org/wiki/Jacobi_method