# Seidel


## Description

"In numerical linear algebra, the Gauss–Seidel method, also known as the Liebmann
method or the method of successive displacement, is an iterative method used to solve
a linear system of equations. It is named after the German mathematicians Carl 
Friedrich Gauss and Philipp Ludwig von Seidel, and is similar to the Jacobi 
method. Though it can be applied to any matrix with non-zero elements on the diagonals,
convergence is only guaranteed if the matrix is either diagonally dominant, or 
symmetric and positive definite. It was only mentioned in a private letter from Gauss
to his student Gerling in 1823.[1] A publication was not delivered before 1874 
by Seidel." 
([Wikipedia][wikipedia-seidel])


## Task Graph comparison

### Auto Parallel Task Graph

![AutoParallel Task Graph](./results/local/autoparallel/complete_graph.png)

### User Parallel Task Graph

![UserParallel Task Graph](./results/local/userparallel/complete_graph.png)


[wikipedia-seidel]: https://en.wikipedia.org/wiki/Gauss%E2%80%93Seidel_method